function [w,R]=bode2(fdt,w1,w2)
% [w,R]=bode2(fdt,w1,w2) calcola la risposta in frequenza R=fdt(jw)
% tra w1 e w2, fornendo anche un vettore w opportunamente spaziato
% i punti del vettore delle frequenze vengono infittiti dove serve
% (in corrispondenza di variazioni rapide di modulo e fase)

npunti=10000; % di solito dovrebbero bastare, si puo' anche sforare

w=zeros(npunti,1);
R=zeros(npunti,1);
ww=w1;
deltaw=0.01;
k=0;
RR=feval(fdt,j*ww);
RRold=RR;

flag=0; % segnala se si e' cambiato il passo
while ww<w2
  RR=feval(fdt,j*(ww+deltaw));
  if (abs((RR-RRold)/(abs(RR)+.001))<.04 & flag~=-1)
    deltaw=deltaw*2;
    flag=+1;
  elseif (abs((RR-RRold)/(abs(RR)+.001))>.12 & flag~=+1)
    deltaw=deltaw/2;
    flag=-1;
  else
    k=k+1;
    R(k)=RRold;
    w(k)=ww;
    ww=ww+deltaw;
    RRold=RR;
    flag=0;
  end
end
w=w(1:k);
R=R(1:k);

