% Progetto del regolatore PI

global Kp Ti

% Ricerca pulsazione con sfasamento di G_id_fnm(jw) = -50
wc = fsolve('G_idfnm_fase_50', 0.02)

% Taratura regolatore (Kc e' un fattore correttivo inizializzato a 1)

Kp = 1/abs(G_tot(j*wc))*Kc
Ti = 5/wc

% Margine di fase 
fm = 180 - abs(fase(L_tot(j*wc)))

% Diagramma di Bode funzione d'anello

w1=1e-2;
w2=1e1;

[w,L_tot_jw]=bode2('L_tot',w1,w2);

figure(3);
subplot(211)
semilogx(w,db(L_tot_jw),'b')
title('Diagramma Bode L(s)')
xlabel('Pulsazione [rad/s]');
ylabel('Modulo [dB]');
set(gca,'XTickMode','manual')
set(gca,'XTick',[.01:.01:.1 .2:.1:1 2:10])
grid on

subplot(212)
semilogx(w,fase(L_tot_jw),'b')
axis([0.01 10 -180 -90])
xlabel('Pulsazione [rad/s]');
ylabel('Fase [gradi]');
set(gca,'XTickMode','manual')
set(gca,'XTick',[.01:.01:.1 .2:.1:1 2:10])
grid on

% Diagramma di Bode del modulo di delta omega / delta omega0 e delta omega / delta Pe0 
F1_jw = L_tot_jw./(1+L_tot_jw);
F2_jw = -1./(j*w*Ta)./(1+L_tot_jw);

figure(4);
semilogx(w, db(L_tot_jw), 'k', w,db(F1_jw),'b', w, db(F2_jw), 'r')
title('Diagrammi di Bode del modulo per il sistema di controllo')
xlabel('Pulsazione [rad/s]');
ylabel('Modulo [dB]');
set(gca,'XTickMode','manual')
set(gca,'XTick',[.01:.01:.1 .2:.1:1 2:10])
legend('L(s)','F_{y0}(s)', 'F_d(s)',1);
grid on

