% Calcola risposta in frequenza modello in anello aperto e
% e funzione d'anello con regolatore I

w1=1e-2;
w2=1e1;

% Calcolo risposta del processo G_id(jw)
[w,G_id_jw]=bode2('G_id',w1,w2);

% Calcolo risposta della parte a fase minima processo Gfm(jw)
% (stesse frequenze)
wfm = w;
G_idfm_jw=G_idfm(j*w);

% Calcolo risposta della parte a fase non minima processo Gfnm(jw)
[wfnm,G_idfnm_jw]=bode2('G_idfnm',w1,w2);

% Visualizzazione

% Diagrammi Bode open loop
figure(1);
subplot(211)
semilogx(w,db(G_id_jw),'k',wfm,db(G_idfm_jw),'b',wfnm,db(G_idfnm_jw),'r')
legend('G_{id}(jw)', 'G_{idfm}(jw)', 'G_{idfnm}(jw)',2)
title('Diagrammi Bode G_{id}')
xlabel('Pulsazione [rad/s]');
ylabel('Modulo [dB]');
grid on
set(gca,'XTickMode','manual')
set(gca,'XTick',[.01:.01:.1 .2:.1:1 2:10])

subplot(212)
semilogx(w,fase(G_id_jw),'k',wfm,fase(G_idfm_jw),'b',wfnm,fase(G_idfnm_jw),'r')
legend('G_{id}(jw)', 'G_{idfm}(jw)', 'G_{idfnm}(jw)',2)
xlabel('Pulsazione [rad/s]');
ylabel('Fase [gradi]');
set(gca,'XTickMode','manual')
set(gca,'XTick',[.01:.01:.1 .2:.1:1 2:10])
grid on


% Diagrammi polari open loop
figure(2);
plot(real(G_id_jw), imag(G_id_jw),'k', real(G_idfm_jw), imag(G_idfm_jw), 'b', real(G_idfnm_jw), imag(G_idfnm_jw), 'r');
title('Diagrammi Polari G_{id}')
legend('G_{id}(jw)', 'G_{idfm}(jw)', 'G_{idfnm}(jw)',4)
hold on
plot([-2 2],[0 0],'k--');
plot([0 0],[-1.5 1.5],'k--');
hold off
axis equal

return


